(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Package: SdcCtrl
 * File: GlobalSdcCtrl.typ
 * Author: liub
 * Created: September 09, 2014
 ********************************************************************
 * Data types of package SdcCtrl
 ********************************************************************)

TYPE
	sdcAxisCfg_typ : 	STRUCT 
		moveMode : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SINT;
		sdcHwCfg : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcHwCfg_typ;
		encIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcEncIf32_typ; (*Encoder interface*)
		drvIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcDrvIf32_typ; (*driver interface*)
		dioIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcDiDoIf_typ; (*di do interface*)
	END_STRUCT;
	sdcAxisMonitor_typ : 	STRUCT  (*Position information*)
		setPosIncIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*[increments] Set Position to io-mapping*)
		actPosIncIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*[increments] Act Position to io-mapping*)
		followError : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT;
	END_STRUCT;
	sdcAxisStatus_typ : 	STRUCT 
		moduleOkIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF BOOL; (*IO-mapping*)
		NodestatusIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Status word to io-mapping*)
		statusWordIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Status word to io-mapping*)
		controlWordIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Ctrl word to io-mapping*)
		errorNumberIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Current error number*)
		stateMachine : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF STATE_MACHINE_ENUM; (*current status translate from status word, easy to understand*)
		posOffset : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*internal use*)
	END_STRUCT;
	sdcAxisCmd_typ : 	STRUCT 
		ackError : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF BOOL;
	END_STRUCT;
	sdcAxisCtrl_typ : 	STRUCT 
		cfg : sdcAxisCfg_typ;
		cmd : sdcAxisCmd_typ;
		monitor : sdcAxisMonitor_typ;
		status : sdcAxisStatus_typ;
	END_STRUCT;
END_TYPE
