/********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: sdcCtrl
 * File: sdcCtrl.c
 * Author: siyao.hu
 * Created: 2023.06.10
 ********************************************************************
 * Implementation of program sdcCtrl
 ********************************************************************/

#include <bur/plctypes.h>

#ifdef _DEFAULT_INCLUDES
	#include <AsDefault.h>
#endif
 
///////////////////////////////////////////////////////////////////////////////
//㴨SV630N ϵпģʽ,ֵ(6060h)
// Cia 402 Complete Mode.
/*
1λģʽ(pp)
3ٶģʽ(pv)
4תģʽ(pt)
6ģʽ(hm)
8cspģʽ
9csvģʽ
10cstģʽ
*/
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//趨6040h
//ʹܣ  6  7  15(ʮ)
//:  128Ч
//ע⣺bit0~bit3밴˳ܽŷCiA402״̬л̣ȷԤƵ״̬
/*
0 ϵʼ
1 ʼŷ޹
2 ŷ޹ϡŷ׼
3 ŷ׼áȴŷʹ
4 ȴŷʹܡŷ
5 ŷСȴŷʹ
6 ȴŷʹܡŷ׼
7 ŷ׼áŷ޹
8 ŷСŷ׼
9 ŷСŷ޹
10 ȴŷʹܡŷ޹
11 ŷСͣ
12 ͣŷ޹
13 ͣ
14 ͣ 
15 ϡŷ޹
16 ͣŷ
*/
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/*Cia 402 ޸*/
//#define CONTROLWORD_AND_MASK                0x01FF          /* 0000 0001 1111 1111 - &㱣bit=1*/
#define CONTROLWORD_READY_TO_SWITCH_ON      0x0006     //0110   	ʮ6
#define CONTROLWORD__SWITCH_ON      		0x0007     //0111   	ʮ7  
#define CONTROLWORD_OPERATION_ENABLE        0x000F		//0001 1111 ʮ15
#define CONTROLWORD_FAULT_RESET             0x0080		//1000 0000 ʮ128: Bit7عϸλ
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
//״ֶ̬壨60410010h
/*
Bit0:Ready to switch on		//0Ч 1ЧЧʱʾ ŷ׼
Bit1:Switched on			//0Ч 1ЧЧʱʾ Կŷ
Bit2:Operation enabled		//0Ч 1ЧЧʱʾ ŷ״̬
Bit3:ŷ				//0޹ϣ1й
Bit4:Voltage enabled		//0Ч1ЧЧʱʾ ͨ·ѹ
Bit5:ͣ				//0 ͣЧ 1ͣЧ
Bit6:Switch on disabled		//0Ч 1ЧЧʱʾ ŷ
Bit7:					  //0޾棬1о
Bit8:Զ			   //
Bit9:Զ̿		        //0Ч 1ЧЧʱʾЧ
Bit10:λõ			    //(60400010h bit 8 (ͣ)=0 0λδ1λõ 60400010h bit 8 (ͣ)=1 0У1ٶΪ0)
Bit11:ڲλ״̬		 //0ûеλ 1λ
Bit12:վָ	   //
Bit13:		   //
Bit14:Զ			  //
Bit15:ԭ	   	      //0Ч1ɻԭ㡣
*/
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//ע⣺6040h˳״̬6041hʾŷǰȷ״̬
//Ϊļ״̬֣XʾΪֵ
#define STATUSWORD_AND_MASK                 0x007F          /* 0000 0000 0111 1111 - &㱣bit=1״ֵ̬ĵ7λ*/
//ʼʧ״̬ӦΪNot ready to switch)
//XXXX XXXX X0XX 0000
#define STATUS_NOTREADYTOSWITCHON_MASK      0x004F		//0100 1111
#define STATUS_NOTREADYTOSWITCHON       	0x0000		//0000 0000
//ŷʧ(Switch on disable)
//XXXX XXXX X1XX 0000
#define STATUS_SWITCHEDONDISABLED_MASK     	0x004F		//0100 1111
#define STATUS_SWITCHEDONDISABLED     		0x0040		//0100 0000
//ŷ׼(Ready to switch on)
//XXXX XXXX X01X 0001
#define STATUS_READYTOSWITCHON_MASK          0x006F		//0110 1111
#define STATUS_READYTOSWITCHON          	0x0021		//0010 0001

//ŷ(Switch on)
//XXXX XXXX X01X 0011
#define STATUS_SWITCHEDON_MASK               0x006F		//0110 1111
#define STATUS_SWITCHEDON               	0x0023		//0010 0011

//ŷʹ(Operation enable)
//XXXX XXXX X01X 0111
#define STATUS_OPERATIONENABLED_MASK         0x006F		//0110 1111
#define STATUS_OPERATIONENABLED         	0x0027		//0010 0111

//ͣЧ(Quick stop active)
//XXXX XXXX X00X 0111
#define STATUS_QUICKSTOPACTIVE_MASK          0x006F		//0110 1111
#define STATUS_QUICKSTOPACTIVE          	0x0007		//0000 0111

//ŷϵ״̬ӦΪ(Fault)
//XXXX XXXX X0XX 1000
#define STATUS_FAULT_MASK                 	0x004F		//0100 1111
#define STATUS_FAULT                 		0x0008 		//0000 1000

//ϷӦЧ(Fault reaction active)
//XXXX XXXX X0XX 1111
#define STATUS_FAULTREACTIONACTIVE_MASK      0x004F		//0100 1111
#define STATUS_FAULTREACTIONACTIVE      	0x000F		//0000 1111
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


void _INIT sdcCtrlINIT(void)
{
    /* get task cycle time */
    fRTInfo.enable = 1;
    RTInfo(&fRTInfo);
    cycT = fRTInfo.cycle_time;			/* task class cycle time in us */
    /*SDC interface init*/
    for(index=0;index<SDC_AXIS_NB;index++)
    {
        gSdcAxisCtrl.cfg.moveMode[index] = MOVE_MODE_CYC_POSITION;//ģʽ:  cspģʽ  趨λSDC·
        
		/****************SDC ӿڳʼ***************************/
        gSdcAxisCtrl.cfg.sdcHwCfg[index].EncIf1_Typ = ncSDC_ENC32;    /**/
        
        memset(&tempString,0,sizeof(tempString));
        strcpy(&tempString,"gSdcAxisCtrl.cfg.encIf[");
        if(index < 10)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index;
            tempString[stringIndex+1] = ']';
        }
        else if(index < 99)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index%10;
            tempString[stringIndex+1] = '0'+index/10;
            tempString[stringIndex+2] = ']';     
        }
        strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[index].EncIf1_Name[0],&tempString);
		
		
        /****************SDC Driver ӿڳʼ***************************/    
        gSdcAxisCtrl.cfg.sdcHwCfg[index].DrvIf_Typ = ncSDC_DRVSM32;
        memset(&tempString,0,sizeof(tempString));
        strcpy(&tempString,"gSdcAxisCtrl.cfg.drvIf[");
        if(index < 10)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index;
            tempString[stringIndex+1] = ']';
        }
        else if(index < 99)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index%10;
            tempString[stringIndex+1] = '0'+index/10;
            tempString[stringIndex+2] = ']';       
        }
        strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[index].DrvIf_Name[0],&tempString); 
		
		
        /****************SDC Dio ӿڳʼ***************************/   
        gSdcAxisCtrl.cfg.sdcHwCfg[index].DiDoIf_Typ = ncSDC_DIDO;
        memset(&tempString,0,sizeof(tempString));
        strcpy(&tempString,"gSdcAxisCtrl.cfg.dioIf[");
        if(index < 10)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index;
            tempString[stringIndex+1] = ']';
        }
        else if(index < 99)
        {
            for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
            {
                if(tempString[stringIndex] == 0)break;
            }
            tempString[stringIndex] = '0'+index%10;
            tempString[stringIndex+1] = '0'+index/10;
            tempString[stringIndex+2] = ']';        
        }
        strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[index].DiDoIf_Name[0],&tempString); 
    }
    /****************SDO ʼ***************************/   

}

void _CYCLIC sdcCtrlCYCLIC(void)
{   
    /* SDO ʼ*/

    
    /*sdc ӿڱ*/
    for(index=0;index<SDC_AXIS_NB;index++)
    {
        /*ӿ*/
        gSdcAxisCtrl.cfg.encIf[index].iLifeCnt++;     /**/
        gSdcAxisCtrl.cfg.encIf[index].iEncOK = 1;     /**/
        gSdcAxisCtrl.cfg.encIf[index].iActTime = gSdcAxisCtrl.cfg.drvIf[index].oSetTime;  
        gSdcAxisCtrl.cfg.encIf[index].iActPos = gSdcAxisCtrl.monitor.actPosIncIO[index];     /*ͨIO-Mappingȡ*/
        //gSdcAxisCtrl.cfg.encIf[index].iActPos = gSdcAxisCtrl.monitor.setPosIncIO[0];
        /*gSdcAxisCtrl.cfg.encIf[index].iRefPulseCnt*//*ȴ*/
        /*gSdcAxisCtrl.cfg.encIf[index].iRefPulsePos*//*ȴ*/
        /*ӿ*/
        gSdcAxisCtrl.cfg.drvIf[index].iLifeCnt++;     /**/
//		gSdcAxisCtrl.cfg.drvIf[index].iDrvOK = ((gSdcAxisCtrl.status.statusWordIO[index]>>2) & 0x01)&(!((gSdcAxisCtrl.status.statusWordIO[index]>>3)& 0x01));
//		gSdcAxisCtrl.cfg.drvIf[index].iStatusEnable = gSdcAxisCtrl.cfg.drvIf[index].iDrvOK;
		if(gSdcAxisCtrl.status.stateMachine[index] != STATUS_NOT_READY_TO_SWITCH_ON)/*״̬ Ready to switch on ===== switch off*/
        {
           	gSdcAxisCtrl.cfg.drvIf[index].iDrvOK = 1;
			gSdcAxisCtrl.cfg.drvIf[index].iStatusEnable = 1;
        }
        else
       {
           gSdcAxisCtrl.cfg.drvIf[index].iDrvOK = 0;
			gSdcAxisCtrl.cfg.drvIf[index].iStatusEnable = 0;
       }
        
        /*IOӿ*/
        gSdcAxisCtrl.cfg.dioIf[index].iLifeCntDriveEnable++;      /**/
        gSdcAxisCtrl.cfg.dioIf[index].iLifeCntNegHwEnd++;         /**/
        gSdcAxisCtrl.cfg.dioIf[index].iLifeCntPosHwEnd++;         /**/
        gSdcAxisCtrl.cfg.dioIf[index].iLifeCntReference++;        /**/
        gSdcAxisCtrl.cfg.dioIf[index].iLifeCntDriveReady++;
		//gSdcAxisCtrl.cfg.dioIf[index].iDriveReady = ((gSdcAxisCtrl.status.statusWordIO[index]>>2) & 0x01)&(!((gSdcAxisCtrl.status.statusWordIO[index]>>3)& 0x01));
        if(gSdcAxisCtrl.status.stateMachine[index] == STATUS_OPERATION_ENABLE)/*״̬ Operation enable ===== switch on*/
        {
            gSdcAxisCtrl.cfg.dioIf[index].iDriveReady = 1 ;
        }
        else
        {
            gSdcAxisCtrl.cfg.dioIf[index].iDriveReady = 0;
        }
    }
    /*״̬ --------״ֿ̬*/
    for(index=0;index<SDC_AXIS_NB;index++)
    {
		if (gSdcAxisCtrl.status.statusWordIO[index] != 0)
		{
			gSdcAxisCtrl.status.moduleOkIO[index] = 1;
		}	
		else
		{	gSdcAxisCtrl.status.moduleOkIO[index] = 0;
		}	
		
        /*״ֽ̬ж״̬Ҫλ bit 0,1,2,3,4,5,6*/
        //statusWordAnd[index] = (gSdcAxisCtrl.status.statusWordIO[index] & STATUSWORD_AND_MASK);
        
		if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_NOTREADYTOSWITCHON_MASK)== STATUS_NOTREADYTOSWITCHON)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_NOT_READY_TO_SWITCH_ON;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_SWITCHEDONDISABLED_MASK)== STATUS_SWITCHEDONDISABLED)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_SWITCH_ON_DISABLE;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_READYTOSWITCHON_MASK)== STATUS_READYTOSWITCHON)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_READY_TO_SWITCH_ON;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_SWITCHEDON_MASK)== STATUS_SWITCHEDON)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_SWITCH_ON;
		}
			
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_OPERATIONENABLED_MASK)== STATUS_OPERATIONENABLED)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_OPERATION_ENABLE;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_QUICKSTOPACTIVE_MASK)== STATUS_QUICKSTOPACTIVE)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_QUICK_STOP_ACTIVE;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_FAULT_MASK)== STATUS_FAULT)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_FAULT;
		}
		else if((gSdcAxisCtrl.status.statusWordIO[index] & STATUS_FAULTREACTIONACTIVE_MASK)== STATUS_FAULTREACTIONACTIVE)
		{
			gSdcAxisCtrl.status.stateMachine[index] = STATUS_FAULT_REACTION_ACTIVE;
		}
		//ַ(Ҫжϵǰ״̬ һ˳)
		/*Ϳ*/
		//ʹܣ  6  7  15
		//:  128Ч
		if (gSdcAxisCtrl.cfg.dioIf[index].oDriveEnable == 1)
		{
			if (oDriveEnableDelayCnt[index] > 100000)//100000us=0.1sec
			{
				oDriveEnableDelay[index] = 1;//Bit0(Switch on)λӳλBit3(Operation enable)Bit4(ʹܲ岹λģʽ)
			}
			else
			{	oDriveEnableDelayCnt[index] =oDriveEnableDelayCnt[index] + cycT;
			}	
		}
		else
		{	oDriveEnableDelayCnt[index] = 0;
			oDriveEnableDelay[index] = 0;
		}	
		
		gSdcAxisCtrl.status.controlWordIO[index] = 
			((gSdcAxisCtrl.status.moduleOkIO[index]<<1) + (gSdcAxisCtrl.status.moduleOkIO[index]<<2) + //Bit1:ͨ·+Bit2:ͣЧ
			(gSdcAxisCtrl.cfg.dioIf[index].oDriveEnable)+	//Bit0:Switch on
			(oDriveEnableDelay[index]<<3) + /*(oDriveEnableDelay[index]<<4) +	*///ӳλBit3(Operation enable)*/
			(gSdcAxisCtrl.cmd.ackError[index]<<7));//Bit7:ϸλ(Ч)
        
		/*ʱλȷ*/
		if(gSdcAxisCtrl.cmd.ackError[index] == 1)  errorResetDelay[index] += cycT;    /*us*/
		if(errorResetDelay[index] > ERROR_RESET_DELAY_TIME) 
		{
			gSdcAxisCtrl.cmd.ackError[index] = 0;
			errorResetDelay[index] =0;
		}
		
		//±
        switch(gSdcAxisCtrl.status.stateMachine[index])
        {   
            case STATUS_NOT_READY_TO_SWITCH_ON:
                
                break;
            case STATUS_SWITCH_ON_DISABLE:
                
                break;
            case STATUS_READY_TO_SWITCH_ON:
                
                break;
            case STATUS_SWITCH_ON:
                
                break;
			
            case STATUS_OPERATION_ENABLE:
                
                break;
            case STATUS_QUICK_STOP_ACTIVE:
                
                break;
            case STATUS_FAULT:
                
                break;
            case STATUS_FAULT_REACTION_ACTIVE:
                
                break;
            
            default:
                /*status can not understand,should not happen*/
                break;
        }
        
        
		/*λƫƴ*/
        if(gSdcAxisCtrl.status.stateMachine[index] != STATUS_OPERATION_ENABLE)
        {
            gSdcAxisCtrl.status.posOffset[index] = gSdcAxisCtrl.monitor.actPosIncIO[index] - gSdcAxisCtrl.cfg.drvIf[index].oSetPos;
        }
        gSdcAxisCtrl.monitor.setPosIncIO[index] = gSdcAxisCtrl.cfg.drvIf[index].oSetPos + gSdcAxisCtrl.status.posOffset[index];
    }
}
